/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Lib.xs. Do not edit this file, edit Lib.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Lib.xs"
/*
 * Part of Comedi::Lib
 *
 * Copyright (c) 2009 Manuel Gebele <forensixs@gmx.de>, Germany
 *
 */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <comedilib.h>

int lib_close(comedi_t *dev)
{
   return comedi_close(dev);
}

comedi_t *lib_open(const char *fn)
{
   return comedi_open(fn);
}

int lib_loglevel(int level)
{
   return comedi_loglevel(level);
}

void lib_perror(const char *str)
{
   return comedi_perror(str);
}

const char *lib_strerror(int errnum)
{
   return comedi_strerror(errnum);
}

int lib_errno()
{
   return comedi_errno();
}

int lib_fileno(comedi_t *dev)
{
   return comedi_fileno(dev);
}

int lib_get_n_subdevices(comedi_t *dev)
{
   return comedi_get_n_subdevices(dev);
}

int lib_get_version_code(comedi_t *dev)
{
   return comedi_get_version_code(dev);
}

const char *lib_get_driver_name(comedi_t *dev)
{
   return comedi_get_driver_name(dev);
}

const char *lib_get_board_name(comedi_t *dev)
{
   return comedi_get_board_name(dev);
}

int lib_get_subdevice_type(comedi_t *dev, unsigned int subdev)
{
   return comedi_get_subdevice_type(dev, subdev);
}

int lib_find_subdevice_by_type(comedi_t *dev, int type, unsigned int start)
{
   return comedi_find_subdevice_by_type(dev, type, start);
}

int lib_get_read_subdevice(comedi_t *dev)
{
   return comedi_get_read_subdevice(dev);
}

int lib_get_write_subdevice(comedi_t *dev)
{
   return comedi_get_write_subdevice(dev);
}

int lib_get_subdevice_flags(comedi_t *dev, unsigned int subdev)
{
   return comedi_get_subdevice_flags(dev, subdev);
}

int lib_get_n_channels(comedi_t *dev, unsigned int subdev)
{
   return comedi_get_n_channels(dev, subdev);
}

int lib_range_is_chan_specific(comedi_t *dev, unsigned int subdev)
{
   return comedi_range_is_chan_specific(dev, subdev);
}

int lib_maxdata_is_chan_specific(comedi_t *dev, unsigned int subdev)
{
   return comedi_maxdata_is_chan_specific(dev, subdev);
}

lsampl_t lib_get_maxdata(comedi_t *dev, unsigned int subdev,
                         unsigned int chan)
{
   return comedi_get_maxdata(dev, subdev, chan);
}

int lib_get_n_ranges(comedi_t *dev, unsigned int subdev, unsigned int chan)
{
   return comedi_get_n_ranges(dev, subdev, chan);
}

/* Comedilib returns a pointer to a comedi_range structure */
HV *lib_get_range(comedi_t *dev, unsigned int subdev, unsigned int chan,
                  unsigned int rng)
{
   comedi_range *range;
   HV *range_hash = (HV *)sv_2mortal((SV *)newHV());

   range = comedi_get_range(dev, subdev, chan, rng);
   if (!range) {
      hv_undef(range_hash); /* optional */
      return range_hash;
   }
   
   /*
    * The comedi_range structure contains the following components:
    * double min;
    * double max;
    * unsigned int unit;
    */
   hv_store(range_hash, "min",  3, newSVnv(range->min),  0);
   hv_store(range_hash, "max",  3, newSVnv(range->max),  0);
   hv_store(range_hash, "unit", 4, newSVuv(range->unit), 0);

   return range_hash;
}

int lib_find_range(comedi_t *dev, unsigned int subdev, unsigned int chan,
                   unsigned int unit, double min, double max)
{
   return comedi_find_range(dev, subdev, chan, unit, min, max);
}

int lib_get_buffer_size(comedi_t *dev, unsigned int subdev)
{
    return comedi_get_buffer_size(dev, subdev);
}

int lib_get_max_buffer_size(comedi_t *dev, unsigned int subdev)
{
   return comedi_get_max_buffer_size(dev, subdev);
}

int lib_set_buffer_size(comedi_t *dev, unsigned int subdev, unsigned int size)
{
   return comedi_set_buffer_size(dev, subdev, size);
}

/* _DEPRECATED_ - comedi_trigger */

int lib_do_insn(comedi_t *dev, HV *insn_ref)
{
   SV **insn, **n, **subdev, **chanspec, **data;
   AV *data_arr;
   int len;
   unsigned int *insn_data;
   int i;
   SV **ele;
   comedi_insn cinsn;
   int retval;

   if (!(insn = hv_fetch(insn_ref, "insn", 4, 0)))
      return -1;

   if (!(n = hv_fetch(insn_ref, "n", 1, 0)))
      return -1;

   if (!(subdev = hv_fetch(insn_ref, "subdev", 6, 0)))
      return -1;

   if (!(chanspec = hv_fetch(insn_ref, "chanspec", 8, 0)))
      return -1;

   if (!(data = hv_fetch(insn_ref, "data", 4, 0)))
      return -1;

   if (!(data_arr = (AV *)SvRV(*data)))
      return -1;

   len = av_len(data_arr);
   if (len == -1)
      /* An empty array makes no sense at all */
      return len;

   Newx(insn_data, len + 1, unsigned int);

   for (i = 0; i <= len; i++) {
      if (!(ele = av_fetch(data_arr, i, FALSE)))
         return -1;
      insn_data[i] = SvUV(*ele);
   }

   cinsn.insn = SvUV(*insn);
   cinsn.n = SvUV(*n);
   cinsn.data = insn_data;
   cinsn.subdev = SvUV(*subdev);
   cinsn.chanspec = SvUV(*chanspec);

   if ((retval = comedi_do_insn(dev, &cinsn)) == -1)
      return retval;

   /* Copy back, essential for a number of
    * instructions (e.g. INSN_READ) */
   for (i = 0; i <= len; i++)
      av_store(data_arr, i, newSVuv(cinsn.data[i]));

   return retval;
}

int lib_do_insnlist(comedi_t *dev, HV *insnlist_ref)
{
   SV **n_insns, **insns;
   AV *insns_arr;
   int insns_len;
   comedi_insn *insns_tmp;
   AV **data_arr;
   int *data_len;
   int i;
   SV **insn_ele;
   HV *insn_hash;
   SV **insn, **n, **subdev, **chanspec, **data;
   unsigned int *insn_data;
   int j;
   SV **data_ele;
   comedi_insn cinsn;
   comedi_insnlist insnlist;
   int retval;

   if (!(n_insns = hv_fetch(insnlist_ref, "n_insns", 7, 0)))
      return -1;

   if (n_insns <= 0) /* There's nothing to do */
      return 0;

   if (!(insns = hv_fetch(insnlist_ref, "insns", 5, 0)))
      return -1;

   if (!(insns_arr = (AV *)SvRV(*insns)))
      return -1;

   insns_len = av_len(insns_arr);
   if (insns_len == -1)
      /* An empty array makes no sense at all */
      return insns_len;

   Newx(insns_tmp, insns_len + 1, comedi_insn);
   Newx(data_arr, insns_len + 1, AV *);
   Newx(data_len, insns_len + 1, int);

   for (i = 0; i <= insns_len; i++) {
      if (!(insn_ele = av_fetch(insns_arr, i, FALSE)))
         return -1;

      if (!(insn_hash = (HV *)SvRV(*insn_ele)))
         return -1;

      if (!(insn = hv_fetch(insn_hash, "insn", 4, 0)))
         return -1;

      if (!(n = hv_fetch(insn_hash, "n", 1, 0)))
         return -1;

      if (!(subdev = hv_fetch(insn_hash, "subdev", 6, 0)))
         return -1;
      
      if (!(chanspec = hv_fetch(insn_hash, "chanspec", 8, 0)))
         return -1;

      if (!(data = hv_fetch(insn_hash, "data", 4, 0)))
         return -1;

      if (!(data_arr[i] = (AV *)SvRV(*data)))
         return -1;

      data_len[i] = av_len(data_arr[i]);
      if (data_len[i] == -1)
         continue; /* Or better return -1 ? */

      Newx(insn_data, data_len[i] + 1, unsigned int);

      for (j = 0; j <= data_len[i]; j++) {
         if (!(data_ele = av_fetch(data_arr[i], j, FALSE)))
            return -1;
         insn_data[j] = SvUV(*data_ele);
      }

      cinsn.insn = SvUV(*insn);
      cinsn.n = SvUV(*n);
      cinsn.data = insn_data;
      cinsn.subdev = SvUV(*subdev);
      cinsn.chanspec = SvUV(*chanspec);
   
      insns_tmp[i] = cinsn;
   }

   insnlist.n_insns = SvUV(*n_insns);
   insnlist.insns = insns_tmp;

   retval = comedi_do_insnlist(dev, &insnlist);
   if (retval == -1)
      return retval;

   /* Copy back */
   for (i = 0; i <= insns_len; i++)
      for (j = 0; j <= data_len[i]; j++)
         av_store(data_arr[i], j, newSViv(insnlist.insns[i].data[j]));
   
   return retval;
}

int lib_lock(comedi_t *dev, unsigned int subdev)
{
   return comedi_lock(dev, subdev);
}

int lib_unlock(comedi_t *dev, unsigned int subdev)
{
   return comedi_unlock(dev, subdev);
}

/* _DEPRECATED_ - comedi_to_phys */
/* _DEPRECATED_ - comedi_from_phys */

int lib_data_read(comedi_t *dev, unsigned int subdev, unsigned int chan,
                  unsigned int rng, unsigned int aref, SV *data)
{
   int retval;
   lsampl_t data_tmp;
   SV *sv;

   retval = comedi_data_read(dev, subdev, chan, rng, aref, &data_tmp);
   if (retval == -1)
      return retval;   

   sv = SvRV(data);
   sv_setuv(sv, data_tmp);

   return retval;
}

int lib_data_read_delayed(comedi_t *dev, unsigned int subdev, unsigned int chan,
                          unsigned int rng, unsigned int aref, SV *data,
                          unsigned int ns)
{
   int retval;
   lsampl_t data_tmp;
   SV *sv;

   retval = comedi_data_read_delayed(dev, subdev, chan, rng, aref, &data_tmp,
                                     ns);
   if (retval == -1)
      return retval;

   sv = SvRV(data);
   sv_setuv(sv, data_tmp);

   return retval;
}

int lib_data_read_hint(comedi_t *dev, unsigned int subdev, unsigned int chan,
                       unsigned int rng, unsigned int aref)
{
   return comedi_data_read_hint(dev, subdev, chan, rng, aref);   
}

int lib_data_write(comedi_t *dev, unsigned int subdev, unsigned int chan,
                   unsigned int rng, unsigned int aref, lsampl_t data)
{
   return comedi_data_write(dev, subdev, chan, rng, aref, data);
}

int lib_dio_config(comedi_t *dev, unsigned int subdev, unsigned int chan,
                   unsigned int dir)
{
   return comedi_dio_config(dev, subdev, chan, dir);
}

int lib_dio_get_config(comedi_t *dev, unsigned int subdev, unsigned int chan,
                       SV *dir)
{
   int retval;
   unsigned int dir_tmp;
   SV *sv;

   retval = comedi_dio_get_config(dev, subdev, chan, &dir_tmp);
   if (retval == -1)
      return retval;

   sv = SvRV(dir);
   sv_setuv(sv, dir_tmp);
   
   return retval;
}

int lib_dio_read(comedi_t *dev, unsigned int subdev, unsigned int chan,
                 SV *bit)
{
   int retval;
   unsigned int bit_tmp;
   SV *sv;

   retval = comedi_dio_read(dev, subdev, chan, &bit_tmp);
   if (retval == -1)
      return retval;

   sv = SvRV(bit);
   sv_setuv(sv, bit_tmp);

   return retval;
}

int lib_dio_write(comedi_t *dev, unsigned int subdev, unsigned int chan,
                  unsigned int bit)
{
   return comedi_dio_write(dev, subdev, chan, bit);
}

/* _DEPRECATED_ - comedi_dio_bitfield */

int lib_dio_bitfield2(comedi_t *dev, unsigned int subdev,
                      unsigned int write_mask, SV *bits,
                      unsigned int base_ch)
{
   int retval;
   unsigned int bits_tmp;
   SV *sv;

   retval = comedi_dio_bitfield2(dev, subdev, write_mask, &bits_tmp, base_ch);
   if (retval == -1)
      return retval;

   sv = SvRV(bits);
   sv_setuv(sv, bits_tmp);

   return retval;
}

/* _DEPRECATED_ - comedi_sv_init */
/* _DEPRECATED_ - comedi_sv_update */
/* _DEPRECATED_ - comedi_sv_measure */

/* Not implemented yet - comedi_get_cmd_src_mask */
/* Not implemented yet - comedi_get_cmd_generic_timed */

int lib_cancel(comedi_t *dev, unsigned int subdev)
{
   return comedi_cancel(dev, subdev);
}

/* Not implemented yet - comedi_command */
/* Not implemented yet - comedi_command_test */

int lib_poll(comedi_t *dev, unsigned int subdev)
{
   return comedi_poll(dev, subdev);
}

int lib_set_max_buffer_size(comedi_t *dev, unsigned int subdev,
                            unsigned int max_size)
{
   return comedi_set_max_buffer_size(dev, subdev, max_size);
}

int lib_get_buffer_contents(comedi_t *dev, unsigned int subdev)
{
   return comedi_get_buffer_contents(dev, subdev);
}

int lib_mark_buffer_read(comedi_t *dev, unsigned int subdev,
                         unsigned int num_bytes)
{
   return comedi_mark_buffer_read(dev, subdev, num_bytes);
}

int lib_mark_buffer_written(comedi_t *dev, unsigned int subdev,
                            unsigned int num_bytes)
{
   return comedi_mark_buffer_written(dev, subdev, num_bytes);
}

int lib_get_buffer_offset(comedi_t *dev, unsigned int subdev)
{
   return comedi_get_buffer_offset(dev, subdev);
}

/* _DEPRECATED_ - comedi_get_timer */
/* _DEPRECATED_ - comedi_timed_1chan */

#line 516 "Lib.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 660 "Lib.c"

XS_EUPXS(XS_Comedi__Lib_lib_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	comedi_t *	dev;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_close",
			"dev")
;

	RETVAL = lib_close(dev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_open)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fn");
    {
	const char *	fn = (const char *)SvPV_nolen(ST(0))
;
	comedi_t *	RETVAL;

	RETVAL = lib_open(fn);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, Nullch, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_loglevel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_loglevel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "level");
    {
	int	level = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = lib_loglevel(level);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_perror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_perror)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	str = (const char *)SvPV_nolen(ST(0))
;
#line 527 "Lib.xs"
	I32* temp;
#line 747 "Lib.c"
#line 529 "Lib.xs"
	temp = PL_markstack_ptr++;
	lib_perror(str);
	if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
	  PL_markstack_ptr = temp;
	  XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
	return; /* assume stack size is correct */
#line 758 "Lib.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Comedi__Lib_lib_strerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_strerror)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "errnum");
    {
	int	errnum = (int)SvIV(ST(0))
;
	const char *	RETVAL;
	dXSTARG;

	RETVAL = lib_strerror(errnum);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_errno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_errno)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = lib_errno();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_fileno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_fileno)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	comedi_t *	dev;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_fileno",
			"dev")
;

	RETVAL = lib_fileno(dev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_n_subdevices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_n_subdevices)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	comedi_t *	dev;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_n_subdevices",
			"dev")
;

	RETVAL = lib_get_n_subdevices(dev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_version_code); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_version_code)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	comedi_t *	dev;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_version_code",
			"dev")
;

	RETVAL = lib_get_version_code(dev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_driver_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_driver_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	comedi_t *	dev;
	const char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_driver_name",
			"dev")
;

	RETVAL = lib_get_driver_name(dev);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_board_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_board_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	comedi_t *	dev;
	const char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_board_name",
			"dev")
;

	RETVAL = lib_get_board_name(dev);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_subdevice_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_subdevice_type)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_subdevice_type",
			"dev")
;

	RETVAL = lib_get_subdevice_type(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_find_subdevice_by_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_find_subdevice_by_type)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, type, start");
    {
	comedi_t *	dev;
	int	type = (int)SvIV(ST(1))
;
	unsigned int	start = (unsigned int)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_find_subdevice_by_type",
			"dev")
;

	RETVAL = lib_find_subdevice_by_type(dev, type, start);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_read_subdevice); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_read_subdevice)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	comedi_t *	dev;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_read_subdevice",
			"dev")
;

	RETVAL = lib_get_read_subdevice(dev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_write_subdevice); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_write_subdevice)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	comedi_t *	dev;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_write_subdevice",
			"dev")
;

	RETVAL = lib_get_write_subdevice(dev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_subdevice_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_subdevice_flags)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_subdevice_flags",
			"dev")
;

	RETVAL = lib_get_subdevice_flags(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_n_channels); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_n_channels)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_n_channels",
			"dev")
;

	RETVAL = lib_get_n_channels(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_range_is_chan_specific); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_range_is_chan_specific)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_range_is_chan_specific",
			"dev")
;

	RETVAL = lib_range_is_chan_specific(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_maxdata_is_chan_specific); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_maxdata_is_chan_specific)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_maxdata_is_chan_specific",
			"dev")
;

	RETVAL = lib_maxdata_is_chan_specific(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_maxdata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_maxdata)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, subdev, chan");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	lsampl_t	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_maxdata",
			"dev")
;

	RETVAL = lib_get_maxdata(dev, subdev, chan);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_n_ranges); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_n_ranges)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, subdev, chan");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_n_ranges",
			"dev")
;

	RETVAL = lib_get_n_ranges(dev, subdev, chan);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_range)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "dev, subdev, chan, rng");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	unsigned int	rng = (unsigned int)SvUV(ST(3))
;
	HV *	RETVAL;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_range",
			"dev")
;

	RETVAL = lib_get_range(dev, subdev, chan, rng);
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_find_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_find_range)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "dev, subdev, chan, unit, min, max");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	unsigned int	unit = (unsigned int)SvUV(ST(3))
;
	double	min = (double)SvNV(ST(4))
;
	double	max = (double)SvNV(ST(5))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_find_range",
			"dev")
;

	RETVAL = lib_find_range(dev, subdev, chan, unit, min, max);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_buffer_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_buffer_size)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_buffer_size",
			"dev")
;

	RETVAL = lib_get_buffer_size(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_max_buffer_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_max_buffer_size)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_max_buffer_size",
			"dev")
;

	RETVAL = lib_get_max_buffer_size(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_set_buffer_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_set_buffer_size)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, subdev, size");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	size = (unsigned int)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_set_buffer_size",
			"dev")
;

	RETVAL = lib_set_buffer_size(dev, subdev, size);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_do_insn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_do_insn)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, insn_ref");
    {
	comedi_t *	dev;
	HV *	insn_ref;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_do_insn",
			"dev")
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    insn_ref = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Comedi::Lib::lib_do_insn",
				"insn_ref");
		}
	} STMT_END
;

	RETVAL = lib_do_insn(dev, insn_ref);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_do_insnlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_do_insnlist)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, insnlist_ref");
    {
	comedi_t *	dev;
	HV *	insnlist_ref;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_do_insnlist",
			"dev")
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    insnlist_ref = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Comedi::Lib::lib_do_insnlist",
				"insnlist_ref");
		}
	} STMT_END
;

	RETVAL = lib_do_insnlist(dev, insnlist_ref);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_lock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_lock)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_lock",
			"dev")
;

	RETVAL = lib_lock(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_unlock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_unlock)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_unlock",
			"dev")
;

	RETVAL = lib_unlock(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_data_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_data_read)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "dev, subdev, chan, rng, aref, data");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	unsigned int	rng = (unsigned int)SvUV(ST(3))
;
	unsigned int	aref = (unsigned int)SvUV(ST(4))
;
	SV *	data = ST(5)
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_data_read",
			"dev")
;

	RETVAL = lib_data_read(dev, subdev, chan, rng, aref, data);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_data_read_delayed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_data_read_delayed)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "dev, subdev, chan, rng, aref, data, ns");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	unsigned int	rng = (unsigned int)SvUV(ST(3))
;
	unsigned int	aref = (unsigned int)SvUV(ST(4))
;
	SV *	data = ST(5)
;
	unsigned int	ns = (unsigned int)SvUV(ST(6))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_data_read_delayed",
			"dev")
;

	RETVAL = lib_data_read_delayed(dev, subdev, chan, rng, aref, data, ns);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_data_read_hint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_data_read_hint)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "dev, subdev, chan, rng, aref");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	unsigned int	rng = (unsigned int)SvUV(ST(3))
;
	unsigned int	aref = (unsigned int)SvUV(ST(4))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_data_read_hint",
			"dev")
;

	RETVAL = lib_data_read_hint(dev, subdev, chan, rng, aref);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_data_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_data_write)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "dev, subdev, chan, rng, aref, data");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	unsigned int	rng = (unsigned int)SvUV(ST(3))
;
	unsigned int	aref = (unsigned int)SvUV(ST(4))
;
	lsampl_t	data = (unsigned int)SvUV(ST(5))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_data_write",
			"dev")
;

	RETVAL = lib_data_write(dev, subdev, chan, rng, aref, data);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_dio_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_dio_config)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "dev, subdev, chan, dir");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	unsigned int	dir = (unsigned int)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_dio_config",
			"dev")
;

	RETVAL = lib_dio_config(dev, subdev, chan, dir);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_dio_get_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_dio_get_config)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "dev, subdev, chan, dir");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	SV *	dir = ST(3)
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_dio_get_config",
			"dev")
;

	RETVAL = lib_dio_get_config(dev, subdev, chan, dir);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_dio_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_dio_read)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "dev, subdev, chan, bit");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	SV *	bit = ST(3)
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_dio_read",
			"dev")
;

	RETVAL = lib_dio_read(dev, subdev, chan, bit);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_dio_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_dio_write)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "dev, subdev, chan, bit");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	chan = (unsigned int)SvUV(ST(2))
;
	unsigned int	bit = (unsigned int)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_dio_write",
			"dev")
;

	RETVAL = lib_dio_write(dev, subdev, chan, bit);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_dio_bitfield2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_dio_bitfield2)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "dev, subdev, write_mask, bits, base_ch");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	write_mask = (unsigned int)SvUV(ST(2))
;
	SV *	bits = ST(3)
;
	unsigned int	base_ch = (unsigned int)SvUV(ST(4))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_dio_bitfield2",
			"dev")
;

	RETVAL = lib_dio_bitfield2(dev, subdev, write_mask, bits, base_ch);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_cancel)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_cancel",
			"dev")
;

	RETVAL = lib_cancel(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_poll)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_poll",
			"dev")
;

	RETVAL = lib_poll(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_set_max_buffer_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_set_max_buffer_size)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, subdev, max_size");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	max_size = (unsigned int)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_set_max_buffer_size",
			"dev")
;

	RETVAL = lib_set_max_buffer_size(dev, subdev, max_size);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_buffer_contents); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_buffer_contents)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_buffer_contents",
			"dev")
;

	RETVAL = lib_get_buffer_contents(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_mark_buffer_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_mark_buffer_read)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, subdev, num_bytes");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	num_bytes = (unsigned int)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_mark_buffer_read",
			"dev")
;

	RETVAL = lib_mark_buffer_read(dev, subdev, num_bytes);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_mark_buffer_written); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_mark_buffer_written)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dev, subdev, num_bytes");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	unsigned int	num_bytes = (unsigned int)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_mark_buffer_written",
			"dev")
;

	RETVAL = lib_mark_buffer_written(dev, subdev, num_bytes);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Comedi__Lib_lib_get_buffer_offset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Comedi__Lib_lib_get_buffer_offset)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dev, subdev");
    {
	comedi_t *	dev;
	unsigned int	subdev = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dev = INT2PTR(comedi_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Comedi::Lib::lib_get_buffer_offset",
			"dev")
;

	RETVAL = lib_get_buffer_offset(dev, subdev);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Comedi__Lib); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Comedi__Lib)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Comedi::Lib::lib_close", XS_Comedi__Lib_lib_close);
        newXS_deffile("Comedi::Lib::lib_open", XS_Comedi__Lib_lib_open);
        newXS_deffile("Comedi::Lib::lib_loglevel", XS_Comedi__Lib_lib_loglevel);
        newXS_deffile("Comedi::Lib::lib_perror", XS_Comedi__Lib_lib_perror);
        newXS_deffile("Comedi::Lib::lib_strerror", XS_Comedi__Lib_lib_strerror);
        newXS_deffile("Comedi::Lib::lib_errno", XS_Comedi__Lib_lib_errno);
        newXS_deffile("Comedi::Lib::lib_fileno", XS_Comedi__Lib_lib_fileno);
        newXS_deffile("Comedi::Lib::lib_get_n_subdevices", XS_Comedi__Lib_lib_get_n_subdevices);
        newXS_deffile("Comedi::Lib::lib_get_version_code", XS_Comedi__Lib_lib_get_version_code);
        newXS_deffile("Comedi::Lib::lib_get_driver_name", XS_Comedi__Lib_lib_get_driver_name);
        newXS_deffile("Comedi::Lib::lib_get_board_name", XS_Comedi__Lib_lib_get_board_name);
        newXS_deffile("Comedi::Lib::lib_get_subdevice_type", XS_Comedi__Lib_lib_get_subdevice_type);
        newXS_deffile("Comedi::Lib::lib_find_subdevice_by_type", XS_Comedi__Lib_lib_find_subdevice_by_type);
        newXS_deffile("Comedi::Lib::lib_get_read_subdevice", XS_Comedi__Lib_lib_get_read_subdevice);
        newXS_deffile("Comedi::Lib::lib_get_write_subdevice", XS_Comedi__Lib_lib_get_write_subdevice);
        newXS_deffile("Comedi::Lib::lib_get_subdevice_flags", XS_Comedi__Lib_lib_get_subdevice_flags);
        newXS_deffile("Comedi::Lib::lib_get_n_channels", XS_Comedi__Lib_lib_get_n_channels);
        newXS_deffile("Comedi::Lib::lib_range_is_chan_specific", XS_Comedi__Lib_lib_range_is_chan_specific);
        newXS_deffile("Comedi::Lib::lib_maxdata_is_chan_specific", XS_Comedi__Lib_lib_maxdata_is_chan_specific);
        newXS_deffile("Comedi::Lib::lib_get_maxdata", XS_Comedi__Lib_lib_get_maxdata);
        newXS_deffile("Comedi::Lib::lib_get_n_ranges", XS_Comedi__Lib_lib_get_n_ranges);
        newXS_deffile("Comedi::Lib::lib_get_range", XS_Comedi__Lib_lib_get_range);
        newXS_deffile("Comedi::Lib::lib_find_range", XS_Comedi__Lib_lib_find_range);
        newXS_deffile("Comedi::Lib::lib_get_buffer_size", XS_Comedi__Lib_lib_get_buffer_size);
        newXS_deffile("Comedi::Lib::lib_get_max_buffer_size", XS_Comedi__Lib_lib_get_max_buffer_size);
        newXS_deffile("Comedi::Lib::lib_set_buffer_size", XS_Comedi__Lib_lib_set_buffer_size);
        newXS_deffile("Comedi::Lib::lib_do_insn", XS_Comedi__Lib_lib_do_insn);
        newXS_deffile("Comedi::Lib::lib_do_insnlist", XS_Comedi__Lib_lib_do_insnlist);
        newXS_deffile("Comedi::Lib::lib_lock", XS_Comedi__Lib_lib_lock);
        newXS_deffile("Comedi::Lib::lib_unlock", XS_Comedi__Lib_lib_unlock);
        newXS_deffile("Comedi::Lib::lib_data_read", XS_Comedi__Lib_lib_data_read);
        newXS_deffile("Comedi::Lib::lib_data_read_delayed", XS_Comedi__Lib_lib_data_read_delayed);
        newXS_deffile("Comedi::Lib::lib_data_read_hint", XS_Comedi__Lib_lib_data_read_hint);
        newXS_deffile("Comedi::Lib::lib_data_write", XS_Comedi__Lib_lib_data_write);
        newXS_deffile("Comedi::Lib::lib_dio_config", XS_Comedi__Lib_lib_dio_config);
        newXS_deffile("Comedi::Lib::lib_dio_get_config", XS_Comedi__Lib_lib_dio_get_config);
        newXS_deffile("Comedi::Lib::lib_dio_read", XS_Comedi__Lib_lib_dio_read);
        newXS_deffile("Comedi::Lib::lib_dio_write", XS_Comedi__Lib_lib_dio_write);
        newXS_deffile("Comedi::Lib::lib_dio_bitfield2", XS_Comedi__Lib_lib_dio_bitfield2);
        newXS_deffile("Comedi::Lib::lib_cancel", XS_Comedi__Lib_lib_cancel);
        newXS_deffile("Comedi::Lib::lib_poll", XS_Comedi__Lib_lib_poll);
        newXS_deffile("Comedi::Lib::lib_set_max_buffer_size", XS_Comedi__Lib_lib_set_max_buffer_size);
        newXS_deffile("Comedi::Lib::lib_get_buffer_contents", XS_Comedi__Lib_lib_get_buffer_contents);
        newXS_deffile("Comedi::Lib::lib_mark_buffer_read", XS_Comedi__Lib_lib_mark_buffer_read);
        newXS_deffile("Comedi::Lib::lib_mark_buffer_written", XS_Comedi__Lib_lib_mark_buffer_written);
        newXS_deffile("Comedi::Lib::lib_get_buffer_offset", XS_Comedi__Lib_lib_get_buffer_offset);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
